function [partial_route ref_distance]=randomimprovement(partial_route, Euc_DM) 
 
% reference distance to evaluate improvements
ref_partial_route=[1 partial_route 1]; %inserts node "1" at start/end to compute total distance
ref_distance=0;
for j=1:length(ref_partial_route)-1
  ref_distance=ref_distance+Euc_DM(ref_partial_route(j), ref_partial_route(j+1));
end
if length(partial_route)>1
    ref_distance;
    it= 150; % iterations to improve the partial route 
    for iterations=1:it  
        % Inversion/Flip Operator
        inv_partial_route=partial_route; inv_distance=0;
        pA=ceil(unifrnd(0.0*length(partial_route),length(partial_route))); 
        pB=ceil(unifrnd(0.0*length(partial_route),length(partial_route)));
        while pA==pB pB=ceil(unifrnd(0.0*length(partial_route),length(partial_route))); end
        % Flip segment within positions pA and pB
        if pA<pB
            inv_partial_route(pA:pB)=flip(partial_route(pA:pB));
        else
            inv_partial_route(pB:pA)=flip(partial_route(pB:pA));
        end
        inv_partial_route=[1 inv_partial_route 1]; %inserts node "1" at start/end to compute total distance
        for j=1:length(inv_partial_route)-1
            inv_distance=inv_distance+Euc_DM(inv_partial_route(j),inv_partial_route(j+1));
        end
        % Exchange Operator
        exc_partial_route=partial_route; exc_distance=0;
        exc_partial_route(pA)=partial_route(pB);  exc_partial_route(pB)=partial_route(pA);
        exc_partial_route=[1 exc_partial_route 1];
        for j=1:length(exc_partial_route)-1
            exc_distance=exc_distance+Euc_DM(exc_partial_route(j),exc_partial_route(j+1));
        end
        % Decision process to evaluate improvement
        if inv_distance <= exc_distance
            candidate_route=inv_partial_route; candidate_distance=inv_distance;
        else
            candidate_route=exc_partial_route; candidate_distance=exc_distance;
        end
        if candidate_distance <= ref_distance % new solution is better than current solution
            partial_route=candidate_route; partial_route(1)=[]; partial_route(length(partial_route))=[];
            ref_distance=candidate_distance;
        end
    end
end
    