clear all; clc;% pkg load statistics
N=493; %Number of locations to generate
longitude=[-102 -100]; %Range for longitude
latitude=[20 22]; %Range for latitude
coordinates_unif=[]; coordinates_norm=[];

% Generate geographic data with UNIFORM distribution
for i=1:N
  % Generate random longitude with uniform distribution
  rand_long_unif = unifrnd(longitude(1),longitude(2));
  % Generate random latitude with uniform distribution
  rand_lat_unif = unifrnd(latitude(1),latitude(2));
  coordinates_unif=[coordinates_unif; rand_long_unif rand_lat_unif ];
end

% Visualize uniform data with Latitude-Latitude coordinates 
plot(coordinates_unif(:,1),coordinates_unif(:,2),'*b');
xlabel('Longitude ()');  ylabel('Latitude ()'); grid on;
text_title='Uniform Distribution';
axis ([-120 -90 10 30]);

% Generate geographic data with NORMAL distribution
c=[0.5 1 2 3]; %number of standard deviations for dispersion
mean_long=(longitude(1) + longitude(2))/2; % mean longitude in degrees
mean_lat=(latitude(1) + latitude(2))/2; % mean latitude in degrees
std_long = 2; std_lat = 1; % standard deviation for longitude and latitude 
for j=1:length(c)
  z=c(j);
  for i=1:N                             
    % Generate random longitude with a normal distribution
    rand_long_norm = normrnd(mean_long, unifrnd(-z,z)*std_long);
    % Generate random latitude with a normal distribution
    rand_lat_norm = normrnd(mean_lat, unifrnd(-z,z)*std_lat);                      
    coordinates_norm=[coordinates_norm; rand_long_norm  rand_lat_norm];
  end
  figure
  plot(coordinates_norm(:,1),coordinates_norm(:,2),'*b'); grid on;
  xlabel('Longitude ()');  ylabel('Latitude ()'); axis ([-120 -90 10 30]);
  text_title='Normal Distribution with z = [-Z,+Z]';
  text_title=strrep(text_title,'Z',mat2str(z));
  title (text_title);
end