clear all
clc

%Read file with old coordinates (non-geographic coordinates)
data=textread('d493.tsp','%s','delimiter','\n');
old_coordinates=[];

for i=7:length(data)-1
  [node tx ty]=strread(data{i},'%d %f %f');
  old_coordinates=[old_coordinates; tx ty];
end

% Initialize array for new_coordinates
new_coordinates=zeros(length(old_coordinates(:,1)),2);

% Convert x-coordinates into Longitude coordinates
max_new=-100; min_new=-102;
max_old=max(old_coordinates(:,1));  min_old=min(old_coordinates(:,1));
new_coordinates(:,1)=((max_new-min_new)/(max_old-min_old))*(old_coordinates(:,1)-max_old)+max_new;

% Convert y-coordinates into Latitude coordinates
max_new=22; min_new=20;
max_old=max(old_coordinates(:,2));  min_old=min(old_coordinates(:,2));
new_coordinates(:,2)=((max_new-min_new)/(max_old-min_old))*(old_coordinates(:,2)-max_old)+max_new;


% Visualize data with Latitude-Latitude coordinates 
plot(new_coordinates(:,1),new_coordinates(:,2),'.b');
xlabel('Longitude ()');  ylabel('Latitude ()'); grid on;


